bgf_RoomHandler

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		bgf_AutomaticallyEnterCreatedRoom(Person)
			return TRUE

		//----------------------------------------------------------------------
		bgf_CanCreateRoom(Person)
			return TRUE

		//----------------------------------------------------------------------
		bgf_GetControlCreateRoom(Person)
			return "bgf_createRoom"
		bgf_GetVerbCreateRoom()
			return /bgf_RoomHandler/verb/bgf_createroom

		//----------------------------------------------------------------------
		bgf_DisplayRoomCreationFailure(Person)
			src.bgf_Chat("<span class='bgf_admin'>You are currently unable to create a room.</span>",Filter=FALSE)

		//----------------------------------------------------------------------
		//	This can be used to determine what type of room is added.
		//	This is used both by bgf_createroom() and the default bgf_GetNewArrivalRoom().
		bgf_GetNewRoomType(Request)
			return /bgf_Room

	//==========================================================================
	verb
		//----------------------------------------------------------------------
		bgf_createroom()
			if (!usr)				return
			var/bgf_RoomHandler/H	= usr.bgf_GetRoomHandler()
			if ( !istype(H) )		return
			if ( !H.bgf_CanCreateRoom(usr) )
				H.bgf_DisplayRoomCreationFailure(usr)
				return

			var/rType				= H.bgf_GetNewRoomType(usr)
			if ( !ispath(rType) )	return
			var/bgf_Room/R			= new rType(H)
			if ( !H.p_AddRoom(R) )	return

			if ( H.bgf_AutomaticallyEnterCreatedRoom(usr) )	H.p_Move(usr,R)
