bgf_SpamFilter
	parent_type	= /sf_SpamFilter

	//==========================================================================
	//	Keep track of the handler so its people can be sent the display.

	var/bgf_RoomHandler/bgf_handler

	New(bgf_RoomHandler/Handler)
		if ( istype(Handler) )	src.bgf_handler	= Handler
		..()

	Del()
		src.bgf_handler	= null
		..()

	//==========================================================================
	//	Controls should be defined based on the skin.
	//	I like displaying the values in the buttons.
	proc
		bgf_GetControlMaxLength()
			return "bgf_Max_Length"
		bgf_GetControlPunishment()
			return "bgf_Punishment"
		bgf_GetControlMaxChatsPerPeriod()
			return "bgf_Max_Chats_Per_Period"
		bgf_GetControlPeriod()
			return "bgf_Period"

	sf_UpdateDisplay(client/Viewer)
		.			= ..(Viewer)
		if (.)
			var/myInterface		= src.bgf_GetControlMaxLength()
			if (myInterface)	Viewer	<< output(src.sf_maxLength,myInterface)
			myInterface			= src.bgf_GetControlPunishment()
			if (myInterface)	Viewer	<< output(src.sf_punishment/600,myInterface)
			myInterface			= src.bgf_GetControlMaxChatsPerPeriod()
			if (myInterface)	Viewer	<< output(src.sf_maxChatsPerPeriod,myInterface)
			myInterface			= src.bgf_GetControlPeriod()
			if (myInterface)	Viewer	<< output(src.sf_period/10,myInterface)

	//==========================================================================
	//--------------------------------------------------------------------------
	//	Make sure hosts can't be muted.
	sf_CanMute(Chatter,Message)
		if ( src.sf_ID(Chatter) == ckey(world.host) )	return FALSE
		return ..(Chatter,Message)

	//--------------------------------------------------------------------------
	//	Let people know why Chatter isn't talking.
	sf_Mute(Chatter)
		.	= ..(Chatter)
		if (. && src.bgf_handler)
			src.bgf_handler.bgf_Log("<strong>[Chatter]</strong> has been muted for [src.sf_punishment/600] minute\s.")


